/*
 * Copyright (c) 1996 Barton P. Miller
 * 
 * We provide the Paradyn Parallel Performance Tools (below
 * described as Paradyn") on an AS IS basis, and do not warrant its
 * validity or performance.  We reserve the right to update, modify,
 * or discontinue this software at any time.  We shall have no
 * obligation to supply such updates or modifications or any other
 * form of support to you.
 * 
 * This license is for research uses.  For such uses, there is no
 * charge. We define "research use" to mean you may freely use it
 * inside your organization for whatever purposes you see fit. But you
 * may not re-distribute Paradyn or parts of Paradyn, in any form
 * source or binary (including derivatives), electronic or otherwise,
 * to any other organization or entity without our permission.
 * 
 * (for other uses, please contact us at paradyn@cs.wisc.edu)
 * 
 * All warranties, including without limitation, any warranty of
 * merchantability or fitness for a particular purpose, are hereby
 * excluded.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * Even if advised of the possibility of such damages, under no
 * circumstances shall we (or any other person or entity with
 * proprietary rights in the software licensed hereunder) be liable
 * to you or any third party for direct, indirect, or consequential
 * damages of any character regardless of type of action, including,
 * without limitation, loss of profits, loss of use, loss of good
 * will, or computer failure or malfunction.  You agree to indemnify
 * us (and any other person or entity with proprietary rights in the
 * software licensed hereunder) for any and all liability it may
 * incur to third parties resulting from your use of Paradyn.
 */

#if !defined(alpha_dec_osf4_0)
#error "invalid architecture-os inclusion"
#endif

#ifndef ALPHA_PD_HDR
#define ALPHA_PD_HDR

#include <sys/param.h>
#include <sys/procfs.h>
#define EXIT_NAME "exit"

#define BYTES_TO_SAVE 512 // should be a multiple of sizeof(instruction)

#define START_WALL_TIMER "DYNINSTstartWallTimer"
#define STOP_WALL_TIMER  "DYNINSTstopWallTimer"
#define START_PROC_TIMER "DYNINSTstartProcessTimer"
#define STOP_PROC_TIMER  "DYNINSTstopProcessTimer" 
#define SIGNAL_HANDLER  0

/*extern unsigned AIX_TEXT_OFFSET_HACK;
extern unsigned AIX_DATA_OFFSET_HACK;*/
typedef int handleT; // defined for compatibility with other platforms

struct dyn_saved_regs
{
    gregset_t theIntRegs;
    fpregset_t theFpRegs;
};


#endif
